﻿Imports System.ComponentModel
Imports System.Runtime.CompilerServices

Public MustInherit Class ViewModelBase
    Implements INotifyPropertyChanged, IDisposable

    Private Shared ReadOnly HostProcesses As New List(Of String)({"XDesProc", "devenv", "WDExpress"})
    Public ReadOnly Property IsInDesignMode As Boolean
        Get
            Dim ret = HostProcesses.Contains(Process.GetCurrentProcess().ProcessName)
            Return ret
        End Get
    End Property

    Public Event PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged
    Protected Overridable Sub RaisePropertyChanged(<CallerMemberName> Optional ByVal prop As String = "")
        If prop IsNot Nothing AndAlso prop.Length > 0 Then RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(prop))
    End Sub

    Private _disposedValue As Boolean ' Dient zur Erkennung redundanter Aufrufe.
    ' IDisposable
    Public Overridable Sub Dispose(disposing As Boolean)
        If Not _disposedValue Then
            If disposing Then
            End If
        End If
        _disposedValue = True
    End Sub

    ' Dieser Code wird von Visual Basic hinzugefügt, um das Dispose-Muster richtig zu implementieren.
    Public Sub Dispose() Implements IDisposable.Dispose
        ' Ändern Sie diesen Code nicht. Fügen Sie Bereinigungscode in Dispose(disposing As Boolean) weiter oben ein.

        Dispose(True)
        GC.SuppressFinalize(Me)
    End Sub

End Class